<?php
/**
 *
 * @category        admintool
 * @package         page_permission
 * @author          Andreas Schmidt, Ruud Eisinga / Dev4me
 * @link (v0.3)		webmaster(at)hillschmidt.de, http://www.hillschmidt.de
 * @link (v1)		http://www.dev4me.nl/modules-snippets/opensource/page-pemission/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x / WBCE 
 * @requirements    PHP 7+ and higher
 * @version         1.1.0
 * @lastmodified    November 5, 2021
 *
 */
 
// prevent this file from being accessed directly
if(!defined('WB_PATH')) die(header('Location: index.php'));

class permissions {

	public $pages = array();
	public $groups = array();
	public $viewgroups = array();
	public $groupcount = 0;
	public $pagescount = 0;

	function __construct()  {
		
		$this->get_groups();
		$this->build_pagelist();
		$this->pagescount = count($this->pages);

	}

	function build_page($toggle) {
		global $MOD_PAGE_PERMISSION;
		$span = count($this->groups);
		$rval = '
			<a class="ppbutton" href="javascript:void(0)" onclick="toggle_help_view()">'.$MOD_PAGE_PERMISSION['SHOW_HIDE_HELP'].'</a>
			<div class="explain_permission" id="explain_permission" style="display:none">'.$MOD_PAGE_PERMISSION['TXT_DESCRIPTION'].'</div>
			<form id="page_permission" name="settings" action="'.WB_URL.'/modules/page_permission/save.php" method="post">
			<div class="permissions">
				<div class="permission_header">
					<div class="permission_text">'.$MOD_PAGE_PERMISSION['TXT_TABLE_HEADER1'].'</div>
					<div class="permission_buttons">
						<a class="ppbutton ppadmingroups" href="#" onclick="toggle_admin_view(\'admingroups\',\'viewgroups\');return false;">'.$MOD_PAGE_PERMISSION['TXT_ADMIN_PERMISSION'].'</a>
						<a class="ppbutton ppviewgroups" href="#" onclick="toggle_admin_view(\'viewgroups\',\'admingroups\');return false;">'.$MOD_PAGE_PERMISSION['TXT_VIEW_PERMISSION'].'</a>
					</div>
				</div>
				<br>
			  <table cellpadding="2" cellspacing="0" border="0" summary="Permissions">
			  <thead>
			  <tr style="background:#F3F3F3;"><th class="fixit" >PID</th><th class="fixit" colspan="2">'.$MOD_PAGE_PERMISSION['TXT_TABLE_HEADER3'].'</th>
		';
	
		foreach($this->groups as $group) {
			$disabled = $group['group_id'] == 1 ? 'disabled ':''; 
			$name = $group['group_id'] == 1 ? '':'admingroups'; 

			 $rval .= '<th class="nowrap '.$name.'" align="center">'.$group['name'].'<br />';
			 $rval .= '<input '.$disabled.'type="button" onclick="checkAll('.$group['group_id'].',1);return true;" value="+" />';
			 if($toggle) $rval .= '<input '.$disabled.'type="button" onclick="checkAll('.$group['group_id'].',-1);return true;" value="+/- toggle" />';
			 $rval .= '<input '.$disabled.'type="button" onclick="checkAll('.$group['group_id'].',0);return true;" value="-" />';
			 $rval .= '</th>';
		}
		foreach($this->viewgroups as $group) {
			$disabled = $group['group_id'] == 1 ? 'disabled ':''; 
			if($group['group_id'] > 1) {
				 $rval .= '<th class="nowrap viewgroups" align="center">'.$group['name'].'<br />';
				 $rval .= '<input '.$disabled.'type="button" onclick="checkAll(\'v'.$group['group_id'].'\',1);return true;" value="+" />';
				 if($toggle) $rval .= '<input '.$disabled.'type="button" onclick="checkAll(\'v'.$group['group_id'].'\',-1);return true;" value="+/- toggle" />';
				 $rval .= '<input '.$disabled.'type="button" onclick="checkAll(\'v'.$group['group_id'].'\',0);return true;" value="-" />';
				 $rval .= '</th>';
			 }
		}
		$rval .= '</tr></thead><tbody>';		
		
		$rval .= $this->get_pages();
		
		$rval .= '</tbody></table>';
		$rval .= '</div><br>';
		$rval .= '<input type="submit" name="submit" value="'.$MOD_PAGE_PERMISSION['TXT_SUBMIT'].'" /> ';
		$rval .= '<input type="reset" name="reset" value="'.$MOD_PAGE_PERMISSION['TXT_RESET'].'" />';
		$rval .= '</form>';
		$rval .= '<br><br>';
		

		return $rval;
		
	}

	function build_pagelist($parent = 0) {
		  global $database;
		  $iterated_parents = array(); // keep count of already iterated parents to prevent duplicates
	 
	 
		  if ( $query_pages = $database->query("SELECT * FROM ".TABLE_PREFIX."pages WHERE parent = ".$parent." ORDER BY level, position ASC")) {
				while($res = $query_pages->fetchRow()) {
					$this->pages[] = $res;
					if (!in_array($res['page_id'], $iterated_parents)) {
						$this->build_pagelist($res['page_id']);
						$iterated_parents[] = $res['page_id'];
					}
				}
		  }
	}


	function get_pages( $root_id = 0 ) {
		$rval = '';
		foreach ( $this->pages as $option ) {
			$tab = str_repeat("-- ",$option['level']);
			$rval .= '
			<tr>
				<td class="fixit" align="center">'.$option['page_id'].'</td>
				<td class="fixit" ><a href="'.WB_URL.'/pages'.$option['link'].'.php" target="_blank">'.$tab.$option['page_title'].'</a></td>
				<td><a href="'.WB_URL.'/admin/pages/settings.php?page_id='.$option['page_id'].'"><img style="width:16px;" src="'.WB_URL.'/modules/page_permission/modify.png" alt="mod" /></a></td>'.
				$this->group_check($option).
				'
			</tr>';
		}
		return $rval;;
	}

	function get_groups() {
		global $database;
		 
		$sql = 'SELECT * FROM `'.TABLE_PREFIX.'groups`';
		$res = $database->query("SELECT * FROM `".TABLE_PREFIX."groups` order by `group_id`");
		$this->groupcount = $res->numRows();
		while( $group = $res->fetchRow()) {
			if(stripos($group['system_permissions'],'pages_settings') !== false || stripos($group['system_permissions'],'pages_modify') !== false) {
				$this->groups[] = $group;
			}
			$this->viewgroups[] = $group;
		}
	}

	function group_check($record)  {
		$rval = '';
		$mygroups = explode(',', $record['admin_groups']);
		$vwgroups = explode(',', $record['viewing_groups']);
		foreach($this->groups as $group) {
			$thegroup = $group['group_id'];
			$pid = $record['page_id'];
			$checked = in_array($thegroup,$mygroups) ? 'checked="checked"':''; 
			$disabled = $thegroup == 1 ? 'disabled':''; 
			$name = $thegroup == 1 ? '':'admingroups'; 
			$rval .= '<td class="'.$name.'" align="center"><input class="'.$disabled.'" '.$disabled.' type="checkbox" name="p'.$pid.'[]" value="'.$thegroup.'" '.$checked.' /></td>';
		}
		foreach($this->viewgroups as $group) {
			$thegroup = $group['group_id'];
			$pid = $record['page_id'];

			$checked = in_array($thegroup,$mygroups) ? 'checked="checked"':''; 
			$vis = $record['visibility'] == 'private' || $record['visibility'] == 'registered';
			$disabled = $vis ? '':'disabled'; 
			$name = 'viewgroups'; 
			if($thegroup > 1) {
				$checked = in_array($thegroup,$vwgroups) ? 'checked="checked"':''; 
				$rval .= '<td class="'.$name.'" align="center"><input class="'.$disabled.'" '.$disabled.' type="checkbox" name="v'.$pid.'[]" value="v'.$thegroup.'" '.$checked.' /></td>';
			}
		}
		return $rval;
	}


}
