<?php
/**
 *
 * @category        admintool
 * @package         page_permission
 * @author          Andreas Schmidt, Ruud Eisinga / Dev4me
 * @link (v0.3)		webmaster(at)hillschmidt.de, http://www.hillschmidt.de
 * @link (v1)		http://www.dev4me.nl/modules-snippets/opensource/page-pemission/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x / WBCE 
 * @requirements    PHP 7+ and higher
 * @version         1.1.0
 * @lastmodified    November 5, 2021
 *
 *
 *
 * v0.01 (Andreas Schmidt; 20 August, 2012)
 * + start/initial setup
 * 
 * v0.02 (Andreas Schmidt; 07 September, 2012)
 * + include a menu tree
 * + include a Javascript check before touching the database
 * 
 * v0.03 (Andreas Schmidt; xx Month, 2012)
 * + for each page a link is added to show it in a frontend window
 * + for each page a direct link is added to the actual page's options in the backend
 * + small corrections for proper XML tags
 * + small corrections in language files
 *
 * v1.0.0 - Complete rewrite by Dev4me, PHP8 ready
 *
 * v1.1.0 - Added setting view permissions
 *
 */
 
$module_directory = 'page_permission';
$module_name = 'Multiple Page Permission Setting';
$module_function = 'tool';
$module_version = '1.1.1';
$module_platform = '2.8.x';
if(defined('WBCE_VERSION')) {
	$module_platform = '1.4.x';
	$module_icon = 'fa fa-list';
}
$module_author = 'Andreas Schmidt (2012), Dev4me (2021)';
$module_license = 'GNU General Public License';
$module_description = 'This module allows you to change the admin group setting of multiple pages at once.';

