<?php
/**
 *
 * @category        admintool
 * @package         page_permission
 * @author          Andreas Schmidt, Ruud Eisinga / Dev4me
 * @link (v0.3)		webmaster(at)hillschmidt.de, http://www.hillschmidt.de
 * @link (v1)		http://www.dev4me.nl/modules-snippets/opensource/page-pemission/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x / WBCE 
 * @requirements    PHP 7+ and higher
 * @version         1.1.0
 * @lastmodified    November 5, 2021
 *
 */

$module_description = 'This module allows you to change the admin and viewing group settings of multiple pages at once.';

$MOD_PAGE_PERMISSION = array(
'TXT_DESCRIPTION' => '
<p>This module allows you to change the admin and viewing group settings of multiple pages at once.</p>
<h3>Backend access:</h3>
<ul>
<li>Here you can define which pages should be editable by which groups.</li>
<li>Be careful not to lock out yourself.</li>
<li>The editing rights of the system group "Administrators" cannot be removed.</li>
</ul>

<h3>Frontend access:</h3> 
<ul>
<li>For pages which are "private" oder "registered" you can define which groups should have read access in the frontend.</li>
<li>For pages with all other visibility levels it is not possible to set the read access.</li>
<li>The system group "Administrators" has always read access on all pages.</li>
</ul>

<h3>Available buttons per group:</h3>
<ul>
<li><input type="button" value="+" onclick="" title="This is just an example" /> All pages are assigned to this group.</li>
<li><input type="button" value="+/- toggle"  onclick="" title="This is just an example" /> Toggle selection, i.e. unassigned pages will be assigned and assigned pages will be unassigned from this group.</li>
<li><input type="button" value="-"  onclick="" title="This is just an example" /> All pages will be unassigned from this group.</li>
<li>Apart from that, the access rights can of course also be set manually by activating / deactivating the individual checkboxes.</li>
</ul>

<h3>Remarks:</h3>
<ul>
<li>Click on the page title to open a new tab with the page in the frontend.</li>
<li>Click on <img src="'.WB_URL.'/modules/page_permission/modify.png" alt="mod" border="0" width="16" height="16" /> to edit the settings of that page.</li>
</ul>
',
'TXT_SUBMIT' => 'Save and apply changes',
'TXT_RESET' => 'Discard changes',
'SHOW_HIDE_HELP' => 'Show/Hide help',
'TXT_TABLE_HEADER1' => 'Change permissions for',
'TXT_TABLE_HEADER2' => '',
'TXT_TABLE_HEADER3' => 'Page title',
'TXT_ERROR' => '<b>ERROR</b> for page PageID ',
'TXT_ERROR_HINT' => '.<br /><br /><b>ERROR</b> in setting permission rights!<br />
Each page needs at least ONE administrator group.<br />
<i>Only some changes were put into the database.</i><br /><br />
Please rework your setting.',
'TXT_ADMIN_PERMISSION' => 'Backend access',
'TXT_VIEW_PERMISSION' => 'Frontend access',
);
