<?php
/**
 *
 * @category        admintool
 * @package         page_permission
 * @author          Andreas Schmidt, Ruud Eisinga / Dev4me
 * @link (v0.3)		webmaster(at)hillschmidt.de, http://www.hillschmidt.de
 * @link (v1)		http://www.dev4me.nl/modules-snippets/opensource/page-pemission/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x / WBCE 
 * @requirements    PHP 7+ and higher
 * @version         1.1.0
 * @lastmodified    November 5, 2021
 *
 */

// Create new admin object and print admin header
require('../../config.php');
require_once(WB_PATH.'/framework/class.admin.php');
$admin = new admin('Pages', 'pages_settings');

require_once(WB_PATH.'/framework/functions.php');

if(!file_exists(dirname(__FILE__) .'/languages/' .LANGUAGE .'.php')) {
	require_once(dirname(__FILE__) .'/languages/EN.php');
} else {
	require_once(dirname(__FILE__) .'/languages/' .LANGUAGE .'.php');
}

include(__DIR__ . '/class.permission_settings.php');
$ps = new permissions();

foreach ( $ps->pages as $page ) {
	$sets = array();
	if(isset($_POST['p'.$page['page_id']])) {
		$sets = $_POST['p'.$page['page_id']];
		array_unshift($sets,1); // add admingroup, always on!
		sort($sets,SORT_NUMERIC);
		$new_groups = implode(',',$sets);
		$sql = "UPDATE `".TABLE_PREFIX."pages` SET `admin_groups` = '$new_groups' WHERE `page_id` = '{$page['page_id']}'";
		$database->query($sql);
	}

	//viewing
	$sets = array();
	if(isset($_POST['v'.$page['page_id']])) {
		$sets = $_POST['v'.$page['page_id']];
		array_unshift($sets,1); // add admingroup, always on!
		sort($sets,SORT_NUMERIC);
		$new_groups = implode(',',$sets);
		$new_groups = str_replace('v','', $new_groups);
		$sql = "UPDATE `".TABLE_PREFIX."pages` SET `viewing_groups` = '$new_groups' WHERE `page_id` = '{$page['page_id']}'";
		$database->query($sql);
		}
	
	
	
}

$target_url = ADMIN_URL.'/admintools/tool.php?tool=page_permission';
if($database->is_error()) {
        $admin->print_error($database->get_error(), $target_url );
} else {
        $admin->print_success($MESSAGE['PAGES_SAVED_SETTINGS'], $target_url );
}
$admin->print_footer();
